//  **** BEGIN LICENSE BLOCK ****
//  Copyright(c) 2005-2006 Adam Judson
//
//
//  PhotoMap
//  - display user contributed photos in a map
//
//  This program is free software; you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
//  Place, Suite 330, Boston, MA 02111-1307 USA
//
//  **** END LICENSE BLOCK ****


// base map implementation
function PhotoMapBasePhoto() {
   this.init();
}

PhotoMapBasePhoto.prototype = {
   preferences : PhotoMapPreferences.instance(),

   init : function() {
      this.photos = {};
   },

   setController : function(controller) {
      this.controller = controller;
   },

   clearPhotos : function(photos) {
      if (photos) {
         for (var photo in photos) {
            delete this.photos[photos[photo].id];
         }
      } else {
         // remove them all
         this.photos = {};
      }
   }
}
