//  **** BEGIN LICENSE BLOCK ****
//  Copyright(c) 2005-2006 Adam Judson
//
//
//  PhotoMap
//  - display user contributed photos in a map
//
//  This program is free software; you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
//  Place, Suite 330, Boston, MA 02111-1307 USA
//
//  **** END LICENSE BLOCK ****


// the wrapper for our specific map implementation
function PhotoMapGMapV2() {
   this.init();
}

PhotoMapGMapV2.prototype = {
   __proto__ : new PhotoMapBaseMap(),

   zoomLevels : 16,

   getIncludes : function(preferences) {
      // change from 2.35 to 2 once things settle down...
      return '<script src="http://maps.google.com/maps?file=api&v=2.35&key=' + 
            preferences.getGoogleKey() +
            '" type="text/javascript"></script>\n';
   },

   getOnload : function(homeLat, homeLon, homeZoom) {
      var onloadText =  '    function onLoad() {\n' +
                        '      document.getElementById("mapContainer").controller = photoMapController;\n' +
                        '      \n' +
                        '      var photoMap = new GMap(document.getElementById("mapContainer"));\n' +
                        '      photoMap.setCenter(new GLatLng(' + homeLat + ', ' + homeLon + '), ' + homeZoom + ');\n' +
                        '      photoMap.addControl(new GLargeMapControl());\n' +
                        '      photoMap.addControl(new GMapTypeControl());\n' +
                        '      photoMapController.initMap(photoMap);\n' +
                        '    }\n';
      return onloadText;
   },

   getController : function() {
      var controllerText =    '    function PhotoMapController() {\n' +
                              '      \n' +
                              '      this.initMap = function(photoMap) {\n' +
                              '         this.map = photoMap;\n' +
                              '         this.markers = {};\n' +
                              '      };\n' +
                              '      \n' +
                              '      \n' +
                              '      this.centerAndZoom = function(lat, lon, zoom) {\n' +
                              '         this.map.setCenter(new GLatLng(lat, lon), zoom);\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.getLocation = function() {\n' +
                              '         var centre = this.map.getCenter();\n' +
                              '         return {lat : centre.latDegrees, lon : centre.lngDegrees};\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.getBounds = function() {\n' +
                              '         var bounds = this.map.getBounds();\n' +
                              '         var sw = bounds.getSouthWest();\n' +
                              '         var ne = bounds.getNorthEast();\n' +
                              '         return {minX : Math.min(sw.lngDegrees, ne.lngDegrees), minY : Math.min(sw.latDegrees, ne.latDegrees), ' +
                              '                 maxX : Math.max(sw.lngDegrees, ne.lngDegrees), maxY : Math.max(sw.latDegrees, ne.latDegrees)};\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.getZoom = function() {\n' +
                              '         return this.map.getZoom();\n' +
                              '      };\n' +
                              '      \n' +
                              '      this.setHandler = function(handler) {\n' +
                              '         this.handler = handler;\n' +
                              '         GEvent.addListener(this.map, "moveend", photoMapMoveEnd);\n' +
/*
// the following fails because of a 
// security exception, try it and see
// that makes me think our insertion is 
// safe
                              '         window.alert("Doing bad things now");\n' +
                              '      var request = new XMLHttpRequest();\n' +
                              '      request.open("GET", "http://yahoo.com", false);\n' +
                              '      request.onreadystatechange = function() {\n' +
                              '                                    		if (request.readyState == 4) {\n' +
                              '                                             window.alert(request.responseXML);\n' +
                              '                                          }\n' +
                              '                                    	};\n' +
                              '      request.send(null);\n' +
*/
                              '      };\n' +
                              '      \n' +
                              '      this.moveEnd = function() {\n' +
                              '        this.handler.mapMoved(this.getLocation(), this.getBounds());\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.markerSelected = function(marker, imgObj) {\n' +
                              '        marker.openInfoWindowHtml("<div style=\'white-space:nowrap;\' ><a href=\'\' onclick=\'window.open(\\"" + imgObj.url + "\\");return false;\'>You are here:<br><img width=\'75px\' height=\'75px\' src=\'" + imgObj.smallUrl + "\'/></a></div>");\n' + 
                              '        this.handler.markerSelected(imgObj.lat, imgObj.lon);' +
                              '      }\n' +
                              '      \n' +
                              '      this.infoWindowOpen = function(marker) {\n' +
                              '        marker.pmOpen = true;' +
                              '      }\n' +
                              '      \n' +
                              '      this.infoWindowClose = function(marker) {\n' +
                              '        if (marker && marker.pmOpen) {\n' +
                              '           delete marker.pmOpen;' +
                              '        }\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.clearMarkers = function() {\n' +
                              '        this.map.clearOverlays();\n' +
                              '        this.markers = {};\n' +
                              '        this.map.getInfoWindow().hide();\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.setMapTypeMap = function() {\n' +
                              '        this.map.setMapType(G_NORMAL_MAP);\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.setMapTypeSatellite = function() {\n' +
                              '        this.map.setMapType(G_SATELLITE_MAP);\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.setMapTypeHybrid = function() {\n' +
                              '        this.map.setMapType(G_HYBRID_MAP);\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.getType = function() {\n' +
                              '        if (this.map.getCurrentMapType() == G_HYBRID_MAP) {\n' +
                              '           return "hybrid";\n' +
                              '        } else if (this.map.getCurrentMapType() == G_SATELLITE_MAP) {\n' +
                              '           return "satellite";\n' +
                              '        } else {\n' +
                              '           return "map";\n' +
                              '        }\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.addMarker = function(imgObj) {\n' +
                              '        if (imgObj) {\n' +
                              '           if (!this.markers[imgObj.key()]) {\n' +
                              '              var point = new GLatLng(imgObj.lat, imgObj.lon);\n' +
                              '              var marker = new GMarker(point);\n' +
                              '              GEvent.addListener(marker, "click", function() {photoMapController.markerSelected(marker, imgObj);});\n' +
                              '              GEvent.addListener(marker, "infowindowopen",  function() {photoMapController.infoWindowOpen(marker);});\n' +
                              '              GEvent.addListener(marker, "infowindowclose", function() {photoMapController.infoWindowClose(marker);});\n' +
                              '              this.map.addOverlay(marker);\n' +
                              '              this.markers[imgObj.key()] = marker;\n' +
                              '           }\n' +
                              '        }\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.removeMarker = function(imgObj) {\n' +
                              '        if (imgObj) {\n' +
                              '           var marker = this.markers[imgObj.key()];\n' +
                              '           if (marker) {\n' +
                              '              this.map.removeOverlay(marker);\n' +
                              '              if (marker.pmOpen) {\n' +
                              '                 this.map.getInfoWindow().hide();\n' +
                              '              }\n' +
                              '              delete this.markers[imgObj.key()];\n' +
                              '           }\n' +
                              '        }\n' +
                              '      }\n' +
                              '      \n' +
                              '      this.addCenterMarker = function() {\n' +
                              '        var loc = this.getLocation();\n' +
                              '        var point = new GLatLng(loc.lat, loc.lon);\n' +
                              '        var marker = new GMarker(point);\n' +
                              '        GEvent.addListener(marker, "click", function() {marker.openInfoWindowHtml("<div style=\'white-space:nowrap;\' >This is where the picture will be added.<br>Make sure you are at the right <br>zoom level.</div>");});\n' +
                              '        this.map.addOverlay(marker);\n' +
                              '      }\n' +
                              '      \n' +
                              '    }\n' +
                              '\n' +
                              'photoMapController = new PhotoMapController();\n' + 
                              '\n' +
                              'function photoMapMoveEnd() {\n' +
                              '   photoMapController.moveEnd();\n' +
                              '};\n' +
                              '\n';

      return controllerText;
   },

   ensureInit : function(mapFrame) {
      if (!this.mapController) {
         this.mapController = mapFrame.contentWindow.document.getElementById("mapContainer").wrappedJSObject.controller;
         this.mapController.setHandler(this);
      }
   },

   setLocation : function(lat, lon, zoom) {
      this.mapController.centerAndZoom(lat, lon, this.convertToMapZoom(zoom));
   },

   getLocation : function() {
      return this.mapController.getLocation();
   },

   getBounds : function() {
      return this.mapController.getBounds();
   },

   convertToMapZoom : function(pmZoom) {
      return 17 - pmZoom + 1;
   },

   getZoom : function() {
      var zoom = this.mapController.getZoom();
      var adjustedZoom = 17 - zoom + 1;
      return adjustedZoom;
   },

   addMarker : function(imgObj) {
      this.mapController.addMarker(imgObj);
   },

   removeMarker : function(imgObj) {
      this.mapController.removeMarker(imgObj);
   },

   clearMarkers : function() {
      this.mapController.clearMarkers();
   },

   addCenterMarker : function() {
      this.mapController.addCenterMarker();
   }
}
